<?php
/*
Plugin Name: Persian WordPress
Plugin URI: http://wordpress.org/extend/plugins/persian-world/
Description: It will turn WordPress , bbPress and BuddyPress into Persian ! and also enables awesome features ! <a href="http://codev.ir">This plugin is part of Code Development Projects </a>
Version: 2.8
Author: Danial Hatami
Author URI: http://codev.ir
*/


/*  Copyright 2010-2013  Danial Hatami (email : Great.emperor94@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*/


// fixed memory limit
function persianwordpress() {
	if ( current_user_can( 'manage_options' ) )
		@ini_set( 'memory_limit', '256M' );
}
add_action( 'admin_init', 'persianwordpress' );

// rtl wordpress
$text_direction = "rtl";

// WPLANG code
function persian_wordpress_localization_code() {
	return fa_IR;
}
add_filter('locale', 'persian_wordpress_localization_code');

function persian_wordpress_load_default_textdomain() {
	$fairmo = dirname( __FILE__ ) . "/fa_IR.mo";
	return load_textdomain('default', $fairmo);
}
	add_action('plugins_loaded','persian_wordpress_load_default_textdomain');
	
function persian_wordpress_load_admin_network_textdomain() {
	$fairnetwork = dirname( __FILE__ ) . "/admin-network-fa_IR.mo";
	return load_textdomain('default', $fairnetwork);
}
	add_action('plugins_loaded','persian_wordpress_load_admin_network_textdomain');

function persian_wordpress_load_admin_textadmin() {
	$fairadmin = dirname( __FILE__ ) . "/admin-fa_IR.mo";
	return load_textdomain('default', $fairadmin);
}
	add_action('plugins_loaded','persian_wordpress_load_admin_textadmin');

function bbpress_init() {
  load_plugin_textdomain( 'bbpress', false, dirname( plugin_basename( __FILE__ ) ) ); 
}
add_action('plugins_loaded', 'bbpress_init');

function buddypress_init() {
  load_plugin_textdomain( 'buddypress', false, dirname( plugin_basename( __FILE__ ) ) ); 
}
add_action('plugins_loaded', 'buddypress_init');

// captions

function persian_wordpress_gettext( $text ) {
	static $replace, $keys;

	if ( !is_array($replace) ) {
		$replace = array(

			'Widget' => 'ابزارک',
			'Widegts' => 'ابزارک‌ها',
			'Uopload/Insert' => 'بارگذاری/گذاشتن',
			'Unattached' => 'پیوست‌نشده',
			'Attached to' => 'پیوست به',
			'دسته‌جمعی' => 'گروهی',
			'تقویم' => 'ماه‌نگار',
			'برچسب‌ها' => 'آويزه‌ها',
			'برچسب‌' => 'آويزه',
			'Inactive' => 'غیرفعال',
			'All' => 'همه',
			'Update Available' => 'آماده بروزرسانی',
			'items' => 'مورد',
			'item' => 'مورد',
			'WordPress Blog ' => 'وبگاه وردپرس',
			'Other WordPress News ' => 'از دنیای وردپرس',
			'Spam' => 'هرزنامه',
			'Trash' => 'زباله‌دان',
			'Pending' => 'در انتظار بررسی',
			'Theme' => 'پوسته',
			'خصوصیات' => 'ویژگی‌ها',
			'جفنگ' => 'هرزنامه',
			'وردپرس فارسی' => 'وردپرس',
			'حاشیه' => 'نوشتک',
			'صافی' => 'پالایه',
			'پروتکل' => 'درگاه',
			'شناسنامه' => 'نمایه',
			'ایمیل' => 'پست‌الکترونیک',
			'قوی' => 'مستحکم',
		);
		$keys = array_keys( $replace );
	}

	return str_replace( $keys, $replace, $text );
}

add_filter( 'gettext', 'persian_wordpress_gettext' );
add_filter( 'gettext_with_context', 'persian_wordpress_gettext' );
add_filter( 'ngettext', 'persian_wordpress_gettext' );
add_filter( 'ngettext_with_context', 'persian_wordpress_gettext' );


// tinymce

add_action( "init", "tinymce_rtl_persian_wordpress_add" );

function tinymce_rtl_persian_wordpress_add() {
	if( !current_user_can ( 'edit_posts' ) && !current_user_can ( 'edit_pages' ) ) {
		return;
	}
	if( get_user_option ( 'rich_editing' ) == 'true' ) {
		add_filter( "mce_external_plugins", "tinymce_persian_wordpress_plugin" );
		add_filter( "mce_buttons", "tinymce_rtl_persian_wordpress" );
	}
}
function tinymce_rtl_persian_wordpress($buttons) {
	array_push($buttons, "separator", "ltr", "rtl");
	return $buttons;
}

function tinymce_persian_wordpress_plugin($plugin_array) {
	$plugin_array['directionality'] = includes_url('js/tinymce/plugins/directionality/editor_plugin.js');

	return $plugin_array;
}

function persian_wordpress_tinymce_css( $mce_css ) {
	if ( ! empty( $mce_css ) )
		$mce_css .= ',';

	$mce_css .= plugins_url( 'mce.css', __FILE__ );

	return $mce_css;
}

add_filter( 'mce_css', 'persian_wordpress_tinymce_css' );

// username

function persian_wordpress_user ($username, $raw_username, $strict)
{
	$username = wp_strip_all_tags ($raw_username);
	$username = remove_accents ($username);
	$username = preg_replace ('|%([a-fA-F0-9][a-fA-F0-9])|', '', $username);
	$username = preg_replace ('/&.+?;/', '', $username);
	if ($strict)
	{
		$settings = get_option ('pwusr_settings');
	}
	$username = trim ($username);
	$username = preg_replace ('|\s+|', ' ', $username);

	return $username;
}
add_filter ('sanitize_user', 'persian_wordpress_user', 10, 3);

?>